PROGRAM	Swish640 ;


{ Swish - Super High Res Version }

uses	QDIntf,		{ QuickDraw graphics }
		GSIntf,		{ The "DeskTop"	Toolsets and others }
		MiscTools,	{ Miscellaneous	Tools }
		ConsoleIO;	{ TML Pascal Console I/O routines }

const	ScreenMode		= $80;	{ 640 mode }
		MaxX			= 640;	{ Max X clamp (should correspond to ScreenMode) }
		MaxLines		= 100;  { Max Lines Retained }
	
	
	AppleMenu		= 300;	{ Menu and Menu	Item constants }
		AboutItem	= 301;
	
	FileMenu		= 400;
		QuitItem	= 401;
	
	Editmenu		= 500;
		UndoItem	= 501;
		CutItem		= 502;
		CopyItem	= 503;
		PastItem	= 504;
		ClearItem	= 505;

	SwishMenu		= 600;
	  SwishItem 	= 601;

	GoodMenu		= 700 ;
		ChgIncItem	= 701 ;
		ChgMirItem	= 702 ;
		ChgTailItem	= 703 ;
		StepItem	= 704 ;

var	ToolsZeroPage: Handle;	{ Handle to Zero page memory for Tools }

	AppleMenuStr:	Str255;	{ Menu definition strings }
	FileMenuStr:	Str255;
	EditMenuStr:	Str255;
	SwishMenuStr:	Str255;
	GoodiesMenuStr:	Str255;
	Location:		Str255;
	
	myWind:		NewWindowParamBlk;	{ Globals to create our windows }
	myWindPtr1:	WindowPtr;

	Done:			Boolean;	{ Flag indicating user has chosen Quit }
	Running:		Boolean;	{ Flag indicates whether or not to plot lines }
	NeedBlank:		Boolean;	{ Flag set to clear screen after Dialog }
	MirrorHor:		Boolean;	{ Flag set to do Horizontal Mirroring }
	MirrorVert:		Boolean;	{ Flag set to do Vertical Mirroring }
	
	X1Coord:	array [1..MaxLines] of Integer;	{ X coordinates of end point 1 }
	Y1Coord:	array [1..MaxLines] of Integer;	{ Y coordinates of end point 1 }
	X2Coord:	array [1..MaxLines] of Integer;	{ X coordinates of end point 2 }
	Y2Coord:	array [1..MaxLines] of Integer;	{ Y coordinates of end point 2 }
	
	DeltaX1:	Integer;	{ Delta x for end point 1 }
	DeltaY1:	Integer;	{ Delta y for end point 1 }
	DeltaX2:	Integer;	{ Delta x for end point 2 }
	DeltaY2:	Integer;	{ Delta y for end point 2 }
	MaxInc:		Integer;	{ The maximum delta allowed }
	MinInc:		Integer;	{ The minimum delta allowed }
	I:			Integer;	{ Index into coordinate lists }
	Color:		Integer;	{ The color to be plotted }
	TailLength:	Integer;	{ The number of lines to plot before erasing old ones }
	MyMemoryID:	Integer;	{ Application ID assigned by Memory Mgr }



procedure StartUpGSTools;
{ This routine initializes each of the //GS Tools required for every 
  application.  Depending upon which tools your application requires
  the code in this procedure would change. }
  
var	ToolRec:  ToolTable;

begin

	Location := 'Beginning of StartUpGSTools';
	
{ Startup the Tool Locator, Memory Manager, and Misc. Tools }
	TLStartUp;
	MyMemoryID := MMStartUp;	
	MTStartUp;

{ Allocate 7 pages of memory in bank 0 for use by the GS Tools.
	3 pages for QuickDraw,
	1 page for Event Manager, 
	1 page for Menu Manager,
	1 page for Control Manager,
	1 page for Line Edit }

{ Allocate and point to memory to be used by the tool kit, }	
	ToolsZeroPage := NewHandle (7 * 256,MyMemoryID,fixedBank+fixedBlk+locked,ptr(0)) ;
							   {7  pages, User ID,       Attributes,         bank 0 }

{ Start up all the tools used. }

{ Start up QuickDrawII }
	QDStartUp (LoWord (ToolsZeroPage^),	{ address of 3 page buffer}
   			   ScreenMode, 				{ MaxX graphics resolution }
   			   160, 					{ max pixel map size (bytes)}
   			   MyMemoryID) ;			{ UserID for memeory blocks }
   	 	  
{ Start up the Event Manager }
	EMStartUp (LoWord(ToolsZeroPage^)+$300,	{ low address of 4th zero page }
    		   20,							{ event queue size }
    		   0,							{ X min	clamp }
    		   MaxX,						{ X max	clamp }
    		   0,							{ Y min	clamp }
    		   200,							{ Y max	clamp }
    		   MyMemoryID);					{ User ID for memory blocks }

{ Give a message while we load RAM based tools }
	MoveTo(40,40);
	SetBackColor(0);
	SetForeColor(15);
	DrawString('Loading RAM Based Tools');
   
{ Now load tools required by the application }
	ToolRec.NumTools := 9;
	ToolRec.Tools[1].TSNum := 4;		{ QuickDraw // }
	ToolRec.Tools[1].MinVersion := 1;
	ToolRec.Tools[2].TSNum := 5;		{ Desk Manager }
	ToolRec.Tools[2].MinVersion := 1;
	ToolRec.Tools[3].TSNum := 6;		{ Event Manager }
	ToolRec.Tools[3].MinVersion := 1;
	ToolRec.Tools[4].TSNum := 14;		{ Window Manager }
	ToolRec.Tools[4].MinVersion := 0;
	ToolRec.Tools[5].TSNum := 15;		{ Menu Manager }
	ToolRec.Tools[5].MinVersion := 1;
	ToolRec.Tools[6].TSNum := 16;		{ Control Manager }
	ToolRec.Tools[6].MinVersion := 1;
	ToolRec.Tools[7].TSNum := 21;		{ Dialog Manager }
	ToolRec.Tools[7].MinVersion := 0;
	ToolRec.Tools[8].TSNum := 20;		{ Line Edit }
	ToolRec.Tools[8].MinVersion := 0;
	ToolRec.Tools[9].TSNum := 22;		{ Scrap Manager }
	ToolRec.Tools[9].MinVersion := 0;
	LoadTools(ToolRec);					{ Load the tools I need	}

	if isToolError then begin
		{ add code to ask for Boot disk to be inserted... }
	end;

{ Startup the Window Manager }  
	WindStartUp (MyMemoryID);		{ User ID for memory blocks }
	RefreshDesktop(nil);

{ Startup up the Control Manager }   
	CtlStartUp (MyMemoryID,						{ User ID for memory blocks }
				LoWord(ToolsZeroPage^)+$400);	{ low address of 5th zero page }

{ Startup the Menu Manager }
	MenuStartUp (MyMemoryID,				{ UserID for memory blocks }
				 LoWord(ToolsZeroPage^)+$500);	{ low address of 6th zero page }

{ Startup up the Scrap Manager }
	ScrapStartUp;
   
{ Startup the Line Editor }
	LEStartUp (LoWord(ToolsZeroPage^)+$600,	{ low address of 7th zero page }
			   MyMemoryID);					{ User ID for memory blocks }

{ Startup the Dialog Manager }     
	DialogStartUp (MyMemoryID);	{ User ID for memory blocks }

{ Startup the Desk Manager }
	DeskStartUp;
	
	Location := 'End of StartUpGSTools';

end; { of StartUpGSTools }


procedure ShutDownGSTools;
{ Shut down each of the	//GS Tools initialized previously before exitting
  this application.  If	you change StartUpGSTools this procedure should
  be changed as	well. }
  
begin

	Location := 'Start of ShutDownGSTools';
	
	GrafOff;
	DeskShutDown;
	DialogShutDown;
	LEShutDown;
	ScrapShutDown;
	MenuShutDown;
	WindShutDown;
	CtlShutDown;
	EMShutDown;
	QDShutDown;
	MTShutDown;
	MMShutDown(MyMemoryID);
	TLShutDown;
	
	Location := 'End of ShutDownGSTools';

end; { of ShutDownGSTools}


procedure SetUpMenus;
{ This procedure creates the menus for the application.  NOTE: Variables given as
  arguments to NewMenu MUST be global variables. }
	 
var	Height: Integer;

begin

	Location := 'Start of SetUpMenus';
	
	SetBackColor (0);
	SetForeColor (15);
	AppleMenuStr := concat('>>@\XN300\0',
						   '==About Swish...\N301V\0');
	FileMenuStr := concat('>>   File   \N400\0',
						  '==Quit\N401*Qq\0.');
	EditMenuStr := concat('>>   Edit   \N500\0',
						  '==Undo\N501DV*Zz\0',
						  '==Cut\N502D*Xx\0',
						  '==Copy\N503D*Cc\0',
						  '==Paste\N504D*Vv\0',
						  '==Clear\N505D\0.');
	SwishMenuStr := concat('>>   Swish  \N600\0',
						   '==Begin/Continue\N601*Bb\0.');
	GoodiesMenuStr := concat('>>  Goodies \N700\0',
							 '==Change Increments\N701*Ii\0',
							 '==Change Mirroring\N702*Mm\0',
							 '==Change Tail Length\N703*Tt\0',
							 '==Stop/Step\N704*Ss\0');

	SetMTitleStart(10);

	InsertMenu (NewMenu (@GoodiesMenuStr[1]), 0);	{ Goodies Menu }
	InsertMenu (NewMenu (@SwishMenuStr[1]), 0);		{ Windows Menu }
	InsertMenu (NewMenu (@EditMenuStr[1]), 0);		{ Edit Menu }
	InsertMenu (NewMenu (@FileMenuStr[1]), 0);		{ File Menu }
	InsertMenu (NewMenu (@AppleMenuStr[1]), 0);		{ Apple	Menu }

	Height := FixMenuBar;			{ Set sizes of menus }

	DrawMenuBar;					{ ... and draw the menu	bar! }
	
	{ Disable the Edit Menu items since this program doesn't support them or NDA's }
	DisableMItem(UndoItem);
	DisableMItem(CutItem);
	DisableMItem(CopyItem);
	DisableMItem(PastItem);
	DisableMItem(ClearItem);
	
	Location := 'End of SetUpMenus';
	
end;{ of SetUpMenus }


procedure SetUpWindow;
{ This procedure sets up the window }

begin

	Location := 'Start of SetUpWindow';

	with myWind do begin
   		param_length		:= sizeof(NewWindowParamBlk);
   		wFrame				:= $4020;
   		wTitle				:= nil;
   		wRefCon				:= 0;
  		wColor				:= nil;
 		wYOrigin			:= 0;
		wXOrigin			:= 0;
   		wDataH				:= 0;
   		wDataW				:= 0;
   		wMaxH				:= 0;
   		wMaxW				:= 0;
   		wScrollVer			:= 0;
   		wScrollHor			:= 0;
   		wPageVer			:= 0;
   		wPageHor			:= 0;
   		wInfoRefCon			:= 0;
   		wInfoHeight			:= 0;
   		wFrameDefProc		:= nil;
   		wInfoDefProc		:= nil;
   		wContDefProc		:= nil;
   		wPosition.top		:= 0;
   		wPosition.left		:= 0;
   		wPosition.bottom	:= 200;
   		wPosition.right		:= MaxX;
   		wPlane				:= -1;
  		wStorage			:= nil;
  	end; { of with }

	myWindPtr1 := NewWindow(myWind);
	
	Location := 'End of SetUpWindow';
	   
end; { of SetUpWindow }


function ScaledRandomInt (MinArg: Integer;
						  MaxArg: Integer) : Integer;

var	Fraction:	real;
	Sign:		integer;

begin

	Location := 'Start of ScaledRandomInt';

	Fraction := Random / 32767;
	If Fraction < 0 then Sign := -1 else Sign := 1;
	ScaledRandomInt := Sign * Trunc ((MaxArg - MinArg + 1) * abs(Fraction) + MinArg);
	
	Location := 'End of ScaledRandomInt';
	
end; { of ScaledRandomInt }


procedure DataInitialization;

var X:			integer;
	Week:		integer;
	Month:		integer;
	Day:		integer;
	Year:		integer;
	Hour:		integer;
	Minute:		integer;
	Second:		integer;
	RandSeed:	longint;
	r:			rect;

begin

	Location := 'Start of DataInitialization';

	I := 1;
	ReadTimeHex (Week,Month,Day,Year,Hour,Minute,Second);
	RandSeed := (((((Week * 10 + Month)
						  * 10 + Day)
						  * 10 + Year)
						  * 10 + Hour)
						  * 10 + Minute)
						  * 10 + Second;
	SetRandSeed (RandSeed);
	Color := Abs (ScaledRandomInt (1,15));

	X1Coord[I] := Abs (ScaledRandomInt (1,MaxX));
	Y1Coord[I] := Abs (ScaledRandomInt (12,200));
	X2Coord[I] := Abs (ScaledRandomInt (1,MaxX));
	Y2Coord[I] := Abs (ScaledRandomInt (12,200));
	
	MinInc := 1;
	MaxInc := 10;
	TailLength := 35;
	
	DeltaX1 := ScaledRandomInt (MinInc,MaxInc);
	DeltaY1 := ScaledRandomInt (MinInc,MaxInc);
	DeltaX2 := ScaledRandomInt (MinInc,MaxInc);
	DeltaY2 := ScaledRandomInt (MinInc,MaxInc);
	
	SetDithColor (0);
	SetRect (r,0,12,MaxX,200);
	PaintRect (r);
	
	MirrorHor := false;
	MirrorVert := false;
	
	Location := 'End of DataInitialization';

end; { of DataInitialization }


procedure DoAbout;
{ This procedure is called when the 'About ...' item is selected from the
  apple menu. }

var	aboutDlog:	DialogPtr;
	r:			Rect;
	itemHit:	Integer;
	AboutMaxX:	Integer;

begin

	Location := 'Start of DoAbout';

	with r do begin
		top := 30; left := Trunc (0.1 * MaxX);
		bottom :=	170; right := Trunc (0.9*maxX);
	end; { of with }
	AboutMaxX := Trunc (0.9 * MaxX) - Trunc (0.1 * MaxX);
	aboutDlog := NewModalDialog(r,true,0);
	SetPort(aboutDlog);
	with r do begin
		top := 90; left := Trunc (0.75 * AboutMaxX);
		bottom := 105; right := Trunc (0.95 * AboutMaxX);
	end; { of with }
	NewDItem(aboutDlog,1,r,10,@'Ok',0,0,nil);
	SetDefButton(1,aboutDlog);
	SetForeColor(0);
	SetBackColor(15);
	MoveTo(10,15);  DrawString('Swish - Super High Res Version');
	MoveTo(10,25);  DrawString('A TML Pascal Demo.');
	MoveTo(10,40);	DrawString('Certain portions of this software');
	MoveTo(10,50);	DrawString('copyrighted by TML Systems, Inc.');
	MoveTo(10,65);  DrawString('Copyright (c) 1987');
	MoveTo(30,75);  DrawString('by TML Systems, Inc. and');
	MoveTo(30,85);  DrawString('by Survival Systems, Inc.');
	MoveTo(10,105);	DrawString('Joseph A. Bouchard');
	MoveTo(10,115); DrawString('P.O.Box 930216');
	MoveTo(10,125); DrawString('Norcross, GA  30093');
	itemHit := ModalDialog(nil);
	NeedBlank := true;
	CloseDialog(aboutDlog);
	
	Location := 'End of DoAbout';

end ; { of DoAbout }


procedure ChangeIncrement;
{ This procedure changes the minimum and maximum increments used to calculate the
  next position of the end-points using a dialog box }

var	OldMinInc:		Integer;	{ Save area for MinInc in case 'cancel' is selected }
	OldMaxInc:		Integer;	{ Save area for MaxInc in case 'cancel' is selected }
	ItemHit:		Integer;	{ Area where mouse down occured }
	ChangeMaxX:		Integer;	{ Window's Max X value }
	NewMinInc:		Str255;		{ MinInc changed by the user }
	NewMaxInc:		Str255;		{ MaxInc changed by the user }
	InputOK:		Boolean;	{ Flag for all input OK }
	MinOK:			Boolean;	{ Flag for input MinInc OK }
	MaxOk:			Boolean;	{ Flag for input MaxInc OK }
	r:				Rect;		{ Rectangle for drawing things in }
	IncrementDlog:	DialogPtr;	{ Pointer to the dialog record }

begin

	Location := 'Start of ChangeIncrement';
	
	{ Initialize variables for this routine }
	OldMinInc := MinInc;
	OldMaxInc := MaxInc;
	InputOK := false;
	MinOK := false;
	MaxOk := false;
	NewMinInc := IntToString(MinInc);
	NewMaxInc := IntToString(MaxInc); 
	
	{ Set up the Dialog Box and make it the current graphics port. }
	with r do begin
		top := 30; left := Trunc (0.1 * MaxX);
		bottom := 140; right := Trunc (0.9 * MaxX);
	end; { of with }
	ChangeMaxX := Trunc (0.9 * MaxX) - Trunc (0.1 * MaxX);
	IncrementDlog := NewModalDialog (r,true,0);
	SetPort (IncrementDlog);
	
	{ Set up the buttons that will get us out of this dialog. }
	with r do begin
		top := 90; left := Trunc (0.1 * ChangeMaxX);
		bottom := 105; right := Trunc (0.3 * ChangeMaxX);
	end; { of with }
	NewDItem (IncrementDlog,1,r,10,@'OKAY',0,0,nil);
	with r do begin
		top := 90; left := Trunc (0.65 * ChangeMaxX);
		bottom := 105; right := Trunc (0.9 * ChangeMaxX);
	end; { of with }
	NewDItem (IncrementDlog,2,r,10,@'Cancel',0,0,nil);
	
	{ Define the area's to put the text for Min and Max into }
	with r do begin
		top := 10; left := Trunc (0.05 * ChangeMaxX);
		bottom := 25; right := Trunc (0.95 * ChangeMaxX);
	end;
	NewDItem(IncrementDlog,4,r,15,@'New Minimum Increment (1 - 5)',0,0,nil);
	OffsetRect(r,0,15);
	NewDItem(IncrementDlog,5,r,17,@NewMinInc,1,0,nil);
	OffsetRect(r,0,25);
	NewDItem(IncrementDlog,6,r,15,@'New Maximum Increment (5 - 10)',0,0,nil);
	OffsetRect(r,0,15);
	NewDItem(IncrementDlog,7,r,17,@NewMaxInc,2,0,nil);
	
	{ Now handle events in the dialog }
	repeat
		itemHit := ModalDialog (nil);
		case itemHit of
			1: begin	{ User wants us to accept new Min and Max increments }
				GetIText (IncrementDlog,5,NewMinInc);
				GetIText (IncrementDlog,7,NewMaxInc);
				MinInc := StringToInt(NewMinInc);
				MaxInc := StringToInt(NewMaxInc);
				if (MinInc >= 1) and (MinInc <= 5)
				then
					MinOK := true
				else begin
					{ want code here for an alert about bad MinInc value }
					SysBeep;
					MinInc := OldMinInc;
					NewMinInc := IntToString (MinInc);
					SetIText (IncrementDlog,5,NewMinInc);
					end;
				{ endif }
				if (MaxInc >= 5) and (MaxInc <= 10)
				then
					MaxOK := true
				else begin
					{ want code here for an alert about bad MaxInc value }
					SysBeep;
					MaxInc := OldMaxInc;
					NewMaxInc := IntToString (MaxInc);
					SetIText (IncrementDlog,7,NewMaxInc);
					end;
				{ endif }
				InputOK := MinOK and MaxOK
			end; { of itemHit = 1 }
			2: begin	{ User wants the original values restored }
				MinInc := OldMinInc;
				MaxInc := OldMaxInc;
				InputOK := true;
			end; { of itemHit = 2 }
		end; { of case }
	until InputOK;
	
	{ All done with the Dialog Box.  Close up shop. }
	NeedBlank := true;
	CloseDialog (IncrementDlog);
	
	Location := 'End of ChangeIncrement';

end; { of ChangeIncrement }


procedure ChangeMirroring;
{ This procedure turns horizontal and/or vertical mirroring on and off as desired.}

var	oldMirrorHor:	Boolean;
	oldMirrorVert:	Boolean;
	r:				Rect;
	MirrorDlog:		DialogPtr;
	ItemHit:		Integer;
	ChangeMaxX:		Integer;

begin

	Location := 'Start of ChangeMirroring';

	oldMirrorHor := MirrorHor;
	oldMirrorVert := MirrorVert;
	
	{ Set up the Dialog Box and make it the current graphics port. }
	with r do begin
		top := 50; left := Trunc (0.2 * MaxX);
		bottom := 120; right := Trunc (0.8 * MaxX);
	end; { of with }
	ChangeMaxX := Trunc (0.8 * MaxX) - Trunc (0.2 * MaxX);
	MirrorDlog := NewModalDialog (r,true,0);
	SetPort (MirrorDlog);
	
	{ Set up the buttons that will get them out of this dialog. }
	with r do begin
		top := 50; left := Trunc (0.1 * ChangeMaxX);
		bottom := 65; right := Trunc (0.35 * ChangeMaxX);
	end; { of with }
	NewDItem (MirrorDlog,1,r,10,@'OKAY',0,0,nil);
	with r do begin
		top := 50; left := Trunc (0.55 * ChangeMaxX);
		bottom := 65; right := Trunc (0.9 * ChangeMaxX);
	end; { of with }
	NewDItem (MirrorDlog,2,r,10,@'Cancel',0,0,nil);
	
	{ Set up the check boxes for the mirroring options. }
	with r do begin
		top := 10; left := Trunc (0.1 * ChangeMaxX);
		bottom := 25; right := Trunc (0.9 * ChangeMaxX);
	end; { of with }
	NewDItem (MirrorDlog,3,r,11,@'Horizontal Mirroring',255,0,nil);
	SetDItemValue (ord (MirrorHor),MirrorDlog,3);
	OffsetRect (r,0,15);
	NewDItem (MirrorDlog,4,r,11,@'Vertical Mirroring',255,0,nil);
	SetDItemValue (ord (MirrorVert),MirrorDlog,4);
	
	{ Now handle the events in this dialog }
	repeat
		itemHit := ModalDialog (nil);
		case itemHit of
			2: begin	{ User wants us to restore the old values }
				MirrorHor := oldMirrorHor;
				MirrorVert := oldMirrorVert;
			end; { of itemHit = 2 }
			3: begin	{ User wants to change the Horizontal mirroring flag }
				MirrorHor := not MirrorHor;
				SetDItemValue (ord (MirrorHor),MirrorDlog,itemHit);
			end; { of itemHit = 3 }
			4: begin	{ User wants to change the Vertical mirroring flag }
				MirrorVert := not MirrorVert;
				SetDItemValue (ord (MirrorVert),MirrorDlog,itemHit);
			end; { of itemHit = 4 }
		end; { of case }
	until itemHit < 3;
	
	{ All done with the Dialog Box.  Close up shop. }
	NeedBlank := true;
	CloseDialog (MirrorDlog);
	
	Location := 'End of ChangeMirroring';

end; { of ChangeMirroring }


procedure ChangeTailLength;
{ This procedure changes the number of lines left on the screen using a Dialog box }

var	OldTailLength:	Integer;	{ Save area for TailLength in case 'cancel' is selected }
	ItemHit:		Integer;	{ Area where mouse down occured }
	ChangeMaxX:		Integer;	{ Window's Max X value }
	NewTailLength:	Str255;		{ TailLength changed by the user }
	PromptString:	Str255;		{ Space to hold the prompt string }
	InputOK:		Boolean;	{ Flag for all input OK }
	r:				Rect;		{ Rectangle for drawing things in }
	TailLengthDlog:	DialogPtr;	{ Pointer to the dialog record }

begin

	Location := 'Start of ChangeTailLength';
	
	{ Initialize variables for this routine }
	OldTailLength := TailLength;
	InputOK := false;
	NewTailLength := IntToString(TailLength);
	
	{ Set up the Dialog Box and make it the current graphics port. }
	with r do begin
		top := 50; left := Trunc (0.2 * MaxX);
		bottom := 120; right := Trunc (0.8 * MaxX);
	end; { of with }
	ChangeMaxX := Trunc (0.8 * MaxX) - Trunc (0.2 * MaxX);
	TailLengthDlog := NewModalDialog (r,true,0);
	SetPort (TailLengthDlog);
	
	{ Set up the buttons that will get us out of this dialog. }
	with r do begin
		top := 50; left := Trunc (0.1 * ChangeMaxX);
		bottom := 65; right := Trunc (0.35 * ChangeMaxX);
	end; { of with }
	NewDItem (TailLengthDlog,1,r,10,@'OKAY',0,0,nil);
	with r do begin
		top := 50; left := Trunc (0.6 * ChangeMaxX);
		bottom := 65; right := Trunc (0.9 * ChangeMaxX);
	end; { of with }
	NewDItem (TailLengthDlog,2,r,10,@'Cancel',0,0,nil);
	
	{ Define the area's to put the text Tail Length into }
	with r do begin
		top := 10; left := Trunc (0.05 * ChangeMaxX);
		bottom := 25; right := Trunc (0.95 * ChangeMaxX);
	end;
	PromptString := concat ('New Tail Length (1 - ',
							IntToString(MaxLines - 1),
							')');
	NewDItem (TailLengthDlog,4,r,15,@PromptString,0,0,nil);
	OffsetRect(r,0,15);
	NewDItem(TailLengthDlog,5,r,17,@NewTailLength,2,0,nil);
	
	{ Now handle events in the dialog }
	repeat
		itemHit := ModalDialog (nil);
		case itemHit of
			1: begin	{ User wants us to accept new TailLength }
				GetIText (TailLengthDlog,5,NewTailLength);
				TailLength := StringToInt(NewTailLength);
				if (TailLength >= 1) and (TailLength < MaxLines)
				then
					InputOK := true
				else begin
					{ want code here for an alert about bad MinInc value }
					SysBeep;
					TailLength := OldTailLength;
					NewTailLength := IntToString (TailLength);
					SetIText (TailLengthDlog,5,NewTailLength);
					end;
				{ endif }
			end; { of itemHit = 1 }
			2: begin	{ User wants the original values restored }
				TailLength := OldTailLength;
				InputOK := true;
			end; { of itemHit = 2 }
		end; { of case }
	until InputOK;
	
	{ All done with the Dialog Box.  Close up shop. }
	NeedBlank := true;
	CloseDialog (TailLengthDlog);
	
	Location := 'End of ChangeTailLength';

end; { of ChangeTailLength }


procedure RandomBounce (var Coord: integer; var Delta: integer);
{ This procedure handles bouncing end points from the edges of the screen }

var	Sign:	integer;

begin

	Location := 'Start of RandomBounce';

	Coord := Coord - Delta;
	if Delta < 0 then Sign := -1 else Sign := 1;
	Delta := -1 * Sign * abs (ScaledRandomInt (MinInc,MaxInc));
	Color := abs (ScaledRandomInt (1,15));
	
	Location := 'Start of RandomBounce';
	
end;


procedure DoLines;
{ This procedure draws new lines, erases old ones, and accounts for mirroring. }

var	I2:	integer;

begin

	Location := 'Start of DoLines';
	
	{ Decice how far back to erase lines }
	I2 := I - TailLength;
	if I2 < 1 then I2 := I2 + MaxLines;

	{ Draw a new line }
	SetDithColor (Color);
	MoveTo (X1Coord[I],Y1Coord[I]);
	LineTo (X2Coord[I],Y2Coord[I]);
	
	{ Mirror Horizontally }
	if MirrorHor then begin
		MoveTo (MaxX - X1Coord[I],Y1Coord[I]);
		LineTo (MaxX - X2Coord[I],Y2Coord[I]);
	end; 
	
	{ Mirror Vertically }
	if MirrorVert then begin
		MoveTo (X1Coord[I],213 - Y1Coord[I]);
		LineTo (X2Coord[I],213 - Y2Coord[I]);
	end;
	
	{ Miror Both }
	if MirrorHor and MirrorVert then begin
		MoveTo (MaxX - X1Coord[I],213 - Y1Coord[I]);
		LineTo (MaxX - X2Coord[I],213 - Y2Coord[I]);
	end;
	
	{ Erase the old line(s) by "blacking" it out }
	SetDithColor (0);
	MoveTo (X1Coord[I2],Y1Coord[I2]);
	LineTo (X2Coord[I2],Y2Coord[I2]);
	if MirrorHor then begin
		MoveTo (MaxX - X1Coord[I2],Y1Coord[I2]);
		LineTo (MaxX - X2Coord[I2],Y2Coord[I2]);
	end;
	if MirrorVert then begin
		MoveTo (X1Coord[I2],213 - Y1Coord[I2]);
		LineTo (X2Coord[I2],213 - Y2Coord[I2]);
	end;
	if MirrorHor and MirrorVert then begin
		MoveTo (MaxX - X1Coord[I2],213 - Y1Coord[I2]);
		LineTo (MaxX - X2Coord[I2],213 - Y2Coord[I2]);
	end;

	{ Figure out the coordinates of the next line to draw }
	I := I + 1;
	if I > MaxLines then begin
		I := 1;
		I2 := MaxLines;
		end
	else begin
		I2 := I - 1
		end;
	{ endif }
	X1Coord[I] := X1Coord[I2] + DeltaX1;
	Y1Coord[I] := Y1Coord[I2] + DeltaY1;
	X2Coord[I] := X2Coord[I2] + DeltaX2;
	Y2Coord[I] := Y2Coord[I2] + DeltaY2;
	
	{ If an end point will be out of bounds, bounce it in a random direction }
	if (X1Coord[I] < 1) or (X1Coord[I]  > MaxX) then RandomBounce (X1Coord[I],DeltaX1);
	if (Y1Coord[I] < 12) or (Y1Coord[I]  > 200) then RandomBounce (Y1Coord[I],DeltaY1);
	if (X2Coord[I] < 1) or (X2Coord[I]  > MaxX) then RandomBounce (X2Coord[I],DeltaX2);
	if (Y2Coord[I] < 12) or (Y2Coord[I]  > 200) then RandomBounce (Y2Coord[I],DeltaY2);
	
	Location := 'End of DoLines';
	
end; { of DoLines }


procedure ProcessMenu(codeWord : Longint);

var	menuNum:    Integer;
	itemNum:    Integer;

begin

	Location := 'Start of ProcessMenu';

	menuNum := HiWord(codeWord);
	itemNum := LoWord(codeWord);
	case itemNum of
		AboutItem:		DoAbout;
		QuitItem:		Done := true;
		SwishItem:		Running := True;
		ChgIncItem:		ChangeIncrement;
		ChgMirItem:		ChangeMirroring;
		ChgTailItem:	ChangeTailLength;
		StepItem: begin
			Running := False;
			DoLines;
		end; { of StepItem }
	end; { of case }

	HiliteMenu(false,menuNum);
	SetPort (myWindPtr1);

end; { of ProcessMenu }


procedure MainEventLoop;

var	Event:	EventRecord;
	code:	Integer;
	r:		Rect;
	
begin

	Event.TaskMask := $1FFF; { allow TaskMaster to do everything it can }
	Done := false;

	repeat
	
		{ Handle whatever event code there is }
		code := TaskMaster(-1, Event);
		case code of
		
			{ Event Manager Events	}
			NullEvent:		;
			mouseDown:		;
			mouseUp:		;
			keyDown:		;
			autoKey:		;
			updateEvt:		; 
			activateEvt:	;
			switchEvt:		;
			deskaccEvt:		;
			
			{ Task	Master Events }
			wInDesk:		;
			wInMenuBar:		ProcessMenu(Event.TaskData);
			wInContent: begin
				Running := false;
				DoLines;
			end;
			wInDrag:		;
			wInGrow:		;
			wInGoAway:		;
			wInZoom:		;
			wInInfo:		;
			wInFrame:		;
			
		end; { of case }
		
		if Running and NOT NeedBlank then DoLines	;
		if NeedBlank then begin
			SetDithColor (0);
			SetRect (r,1,12,MaxX,200);
			PaintRect (r);
			NeedBlank := false;
		end;

		
	until Done; { end of repeat }
	
end; { of MainEventLoop	}


{ This is the actual program that gets executed, calling all the above procedures. }

begin

	StartUpGSTools;
	ShowCursor;
	SetUpMenus;
	SetUpWindow;
	DataInitialization;
	MainEventLoop;
	ShutDownGSTools;

END.
